package com.fractalite.hermes.teldar.cfg;


import java.util.ArrayList;
import java.util.List;

import org.apache.camel.Exchange;
import org.apache.camel.processor.aggregate.AggregationStrategy;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.fractalite.models.commerce.PriceScope;
import com.fractalite.models.travel.stay.Hotel;
import com.fractalite.models.travel.stay.StaySearchResults;

public class StaySearchResultsSimpleAggregator implements AggregationStrategy {
	
	
	private static final Logger log = LoggerFactory
			.getLogger(StaySearchResultsSimpleAggregator.class);
	
	@Override
	public Exchange aggregate(Exchange oldExchange, Exchange newExchange) {
		Exchange aggregated=null;
		
		
		try{
		if(oldExchange != null) {
			
			StaySearchResults oldx  = oldExchange.getIn().getBody(StaySearchResults.class);		
			StaySearchResults newx  = newExchange.getIn().getBody(StaySearchResults.class);
			log.info("oldx "+oldx.getHotels().size());
			log.info("newx "+newx.getHotels().size());

			if(oldx == null) {
				// hapens if precedent messages returned errors
				return newExchange;
			}
			else if(newx == null){
				// happens if newExchange has had an error
				return oldExchange;
			}
			/*
			if(newx!=null && newx.getHotels()!=null && newx.getHotels().size()> 0 && newx.getHotels().get(0).getMetas().containsKey("source"))
				log.info("Aggregating..."+newx.getHotels().get(0).getMetaFirst("source"));
			else 
				log.info("Aggregating...");
			*/
			
		//	List<Hotel> toRemove= new ArrayList<Hotel>()  ;
			List<Hotel> toAdd= new ArrayList<Hotel>()  ;
					
			for( Hotel newHotel : newx.getHotels())
			{
					toAdd.add(newHotel);
			}
			oldx.getHotels().addAll(toAdd);
			aggregated = oldExchange;
		}
		else {
			// incase it is the first call to aggregate() : old is null
			
			aggregated = newExchange;
		}
			}
	catch(Exception ee)
		{	log.error("Aggregating Erreur  "+ee.getMessage());
			ee.printStackTrace();
			aggregated=oldExchange;
		}
		
		log.info("Last "+aggregated.getIn().getBody(StaySearchResults.class).getHotels().size());

		return aggregated;
	}

}
